﻿-- Log job journa // bg // frost // id

-- Initialization
local RerollManager = LibStub("AceAddon-3.0"):NewAddon("RerollManager", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub('AceLocale-3.0'):GetLocale('RerollManager')
local LDB = LibStub("LibDataBroker-1.1", true)
local Deformat = LibStub("LibDeformat-3.0", true)
local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)
local RMConfig = LibStub("AceConfig-3.0")
local RMConfigDialog = LibStub("AceConfigDialog-3.0")

local DBDefault = {
	profile = {
		minimap = {
			hide = false,
		},
	},
	char = {
		Fish = { done = -1, handle = true, },
		Cook = { done = -1, handle = true, },
		JC = { done = -1, handle = true, },
		Weekly = { done = -1, handle = true, },
		BG = { done = -1, handle = true, },
		Frost = { done = -1, handle = true, },
		ICC10 = { done = -1, handle = true, }, ICC25 = { done = -1, handle = true, },
		Archa10 = { done = -1, handle = true, }, Archa25 = { done = -1, handle = true, },
		EDC10 = { done = -1, handle = false, }, EDC25 = { done = -1, handle = false, }, EDC10H = { done = -1, handle = false, }, EDC25H = { done = -1, handle = false, }, 
		Uldu10 = { done = -1, handle = false, }, Uldu25 = { done = -1, handle = false, },
		Naxx10 = { done = -1, handle = false, }, Naxx25 = { done = -1, handle = false, },
		Ony10 = { done = -1, handle = false, }, Ony25 = { done = -1, handle = false, },
		Maly10 = { done = -1, handle = false, }, Maly25 = { done = -1, handle = false, },
		Sartha10 = { done = -1, handle = false, }, Sartha25 = { done = -1, handle = false, },
		Ruby10 = { done = -1, handle = false, }, Ruby25 = { done = -1, handle = false, },
	},
}

--Gestion de l'heure
local DailyReset = 3 -- Even if it's 4am sometimes
local WeeklyResetHour = 9 -- ???
local WeeklyResetDay = 4 -- Wednesday

local SkillLocalizedNameByID = { Cook = 2550, Fish = 7620, JC = 25229 }
local SkillRank = { Cook = -1, Fish = -1, JC = -1}
local ListRaids = { "ICC10", "ICC25", "Archa10", "Archa25", "EDC10", "EDC25", "EDC10H", "EDC25H", "Ruby10", "Ruby25", "Ony10", "Ony25", "Uldu10", "Uldu25", "Maly10", "Maly25", "Sartha10", "Sartha25", "Naxx10", "Naxx25" }
local ListJobs = { "Cook", "Fish", "JC" }
local ListMisc = { "BG", "Frost", "Weekly" }

--Quests
local QuestFishing = { 13830, 13832, 13833, 13834, 13836 }
local QuestCooking = { 13100, 13101, 13102, 13103, 13107, 13112, 13113, 13114, 13115, 13116 }
local QuestJC = { 12958, 12959, 12960, 12961, 12962, 12963 }
local QuestWeekly = { 24579, 24580, 24581, 24582, 24583, 24584, 24585, 24586, 24587, 24588, 24589, 24590 }

--DidIDo ? :: -1 = can't do // 0 = didn't do // 1 = doing // 2 = Done
local DidIDo = { 
	ICC10 = -1, ICC25 = -1,
	Archa10 = -1, Archa25 = -1, 
	EDC10 = -1, EDC25 = -1, EDC10H = -1, EDC25H = -1, 
	Uldu10 = -1, Uldu25 = -1, 
	Naxx10 = -1, Naxx25 = -1, 
	Ony10 = -1, Ony25 = -1,
	Maly10 = -1, Maly25 = -1,
	Sartha10 = -1, Sartha25 = -1,
	Ruby10 = -1, Ruby25 = -1,
	Weekly = -1, Frost = -1, BG = -1, 
	JC = -1, Fish = -1, Cook = -1 
	}

function RerollManager:OnInitialize()
	-- Load SV // Register slash
	RerollManager:RegisterChatCommand("rm","SlashHandler")
	self.db = LibStub("AceDB-3.0"):New("RMdb", DBDefault)
	RerollManager:CreateMinimapFrame()
	RerollManager:SetDailyReset()
	
end

function RerollManager:OnEnable()
	-- Register events // hook funct // frames // init funct
	RerollManager:RegisterEvent("UNIT_QUEST_LOG_CHANGED","QuestLogUpdate")
	RerollManager:RegisterEvent("PLAYER_ENTERING_WORLD","CheckBGFrost")
	RerollManager:RegisterEvent("CHAT_MSG_SYSTEM", "HandleChatMessages")
	RerollManager:ScheduleTimer("Loading", 1)

end

function RerollManager:Loading()
	RerollManager:UnregisterEvent("")
	RerollManager:LocalizeSkillName()
	RerollManager:GetSkillRank()
	RerollManager:CheckLevel()
	RerollManager:LoadSV()
	RerollManager:CheckQuest()
	RerollManager:CheckIDs()
	RerollManager:CheckBGFrost()
	RMConfig:RegisterOptionsTable("RerollManager", RMOptions)
	RMConfigDialog:AddToBlizOptions("RerollManager", "RerollManager")
end

--- FUNCTIONS

function RerollManager:SlashHandler()
	-- RerollManager:CheckQuest()
	-- for k,v in pairs(DidIDo) do
		-- if v ~= -1 and Handle[k] then
			-- print(k,v)
		-- end
	-- end
	
	-- local Text = string.format(DAILY_QUESTS_REMAINING,"25")
	-- self:HandleChatMessages(Text)
	
	-- RerollManager:Printf("Actual Time : %s",time())
	-- for k,v in pairs(date('*t')) do
		-- RerollManager:Printf("Actual Date : %s - %s",k,tostring(v))
	-- end
	-- RerollManager:Printf("Reset Time : %s",self:GetLastWeeklyReset())
	-- for k,v in pairs(date('*t',self:GetLastWeeklyReset())) do
		-- RerollManager:Printf("Reset Date : %s - %s",k,tostring(v))
	-- end
	
	self:Printf("Still no slash command options")
end

function RerollManager:SetDone(whatdidido, number)
	DidIDo[whatdidido] = number
	self.db.char[whatdidido].done = number
	self.db.char[whatdidido].date = time()
end

function RerollManager:CheckLevel()
	local lvl = UnitLevel("player")
	if (lvl >= 65) then
		if SkillRank["Cook"] and SkillRank["Cook"] >= 350 then self:SetDone("Cook",0) end
		if SkillRank["JC"] and SkillRank["JC"] >= 350 then self:SetDone("JC",0) end
		if (lvl >= 70) then
			if SkillRank["Fish"] and SkillRank["Fish"] >= 1 then self:SetDone("Fish",0) end
			if (lvl == 80) then
				local array = { "Frost", "BG", "Weekly", "ICC10", "ICC25", "Archa10", "Archa25", "EDC10", "EDC10H", "EDC25", "EDC25H", "Uldu10", "Uldu25", "Naxx10", "Naxx25", "Ony10", "Ony25", "Maly10", "Maly25", "Sartha10",  "Sartha25", "Ruby10", "Ruby25" }
				for k,v in pairs(array) do
					self:SetDone(v,0)
				end
			end
		end
	end
end

-- Check archavon uniquement
function RerollManager:CheckIDs()
	local numInstances = GetNumSavedInstances()
	for i = 1, numInstances do
		local name, id, reset, difficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName = GetSavedInstanceInfo(i)
		if locked and isRaid then
			if name == L["ICC"] then
				if maxPlayers == 25 then 
					self:SetDone("ICC25",1)
				else
					self:SetDone("ICC10",1)
				end
			elseif name == L["Archa"] then
				if maxPlayers == 25 then 
					self:SetDone("Archa25",1)
				else 
					self:SetDone("Archa10",1)
				end
			elseif name == L["EDC"] then
				if maxPlayers == 25 then 
					if difficulty then 
						self:SetDone("EDC25H",1)
					else
						self:SetDone("EDC25",1)
					end 
				else
					if difficulty then
						self:SetDone("EDC10H",1)
					else
						self:SetDone("EDC10",1)
					end 
				end
			elseif name == L["Uldu"] then
				if maxPlayers == 25 then
					self:SetDone("Uldu25",1)
				else
					self:SetDone("Uldu10",1)
				end
			elseif name == L["Naxx"] then
				if maxPlayers == 25 then
					self:SetDone("Naxx25",1)
				else
					self:SetDone("Naxx10",1)
				end
			elseif name == L["Ony"] then
				if maxPlayers == 25 then
					self:SetDone("Ony25",1)
				else
					self:SetDone("Ony10",1)
				end
			elseif name == L["Maly"] then
				if maxPlayers == 25 then
					self:SetDone("Maly25",1)
				else
					self:SetDone("Maly10",1)
				end
			elseif name == L["Sartha"] then
				if maxPlayers == 25 then
					self:SetDone("Sartha25",1)
				else
					self:SetDone("Sartha10",1)
				end
			elseif name == L["Ruby"] then
				if maxPlayers == 25 then
					self:SetDone("Ruby25",1)
				else
					self:SetDone("Ruby10",1)
				end
			end
		end
	end
end

function RerollManager:CheckBGFrost()
	self:CheckIDs()
	if DidIDo["Frost"] == 0 then
		local doneToday = GetLFGDungeonRewards(262) --WotLK randomH
		if doneToday then self:SetDone("Frost",2) end
	end
	if DidIDo["BG"] == 0 then
		local hasWinHoliday = GetHolidayBGHonorCurrencyBonuses()
		local hasWinRandom = GetRandomBGHonorCurrencyBonuses()
		if hasWinHoliday or hasWinRandom then self:SetDone("BG",2) end
	end
end

function RerollManager:QuestLogUpdate(_, unitID)
	if (unitID == "player") then
		self:CheckQuest()
	end
end

function RerollManager:CheckQuest()
	if DidIDo["Fish"] == 0 then
		if self:ScanQuestLog(QuestFishing) then
			self:SetDone("Fish",1)
		end
	end
	if DidIDo["Fish"] == 1 then
		if not self:ScanQuestLog(QuestFishing) then
			self:SetDone("Fish",2)
		end
	end

	if DidIDo["Cook"] == 0 then
		if self:ScanQuestLog(QuestCooking) then
			self:SetDone("Cook",1)
		end
	end
	if DidIDo["Cook"] == 1 then
		if not self:ScanQuestLog(QuestCooking) then
			self:SetDone("Cook",2)
		end
	end

	if DidIDo["JC"] == 0 then
		if self:ScanQuestLog(QuestJC) then
			self:SetDone("JC",1)
		end
	end
	if DidIDo["JC"] == 1 then
		if not self:ScanQuestLog(QuestJC) then
			self:SetDone("JC",2)
		end
	end
	
	if DidIDo["Weekly"] == 0 then
		if self:ScanQuestLog(QuestWeekly) then
			self:SetDone("Weekly",1)
		end
	end
	if DidIDo["Weekly"] == 1 then
		if not self:ScanQuestLog(QuestWeekly) then
			self:SetDone("Weekly",2)
		end
	end
end

function RerollManager:ScanQuestLog(array)
	local _, numQuests = GetNumQuestLogEntries()
	for i = 1,numQuests do
		local _, _, _, _, _, _, _, _, questID = GetQuestLogTitle(i)
		if (tContains( array, questID )) then
			--RerollManager:Printf("Trouvé")
			return true
		end
	end
	return false
end

function RerollManager:LocalizeSkillName()
	for k,v in pairs(SkillLocalizedNameByID) do
		SkillLocalizedNameByID[k] = GetSpellInfo(v)
	end
end

function RerollManager:GetSkillRank()
	local numSkills = GetNumSkillLines()
	for i=1, numSkills do
		local skillName, isHeader, _, skillRank = GetSkillLineInfo(i)
		if not isHeader then
			for k,v in pairs(SkillLocalizedNameByID) do
				if v == skillName then
					SkillRank[k] = skillRank
				end
			end
		end
	end
end

function RerollManager:GetLastDailyReset()
	local DTime = {}
	DTime = date('*t') -- hour, min, wday, day, month, year, sec, yday, isdst
	
	local lastDailyQuestResetDate = { }
	lastDailyQuestResetDate = DTime
	lastDailyQuestResetDate.hour = DailyReset -- On passe l'heure de dernier reset à 3 ou 4h
	local lastDailyQuestResetTime = time(lastDailyQuestResetDate)
	if DTime.hour < DailyReset then -- Si le reset est après l'heure actuelle (ce qui arrive lorsqu'il est entre 0h et 3h)
	-- On retranche 24h au timer
		lastDailyQuestResetTime = lastDailyQuestResetTime - ( 24 * 60 * 60 )
	end
	return lastDailyQuestResetTime
end

function RerollManager:GetLastWeeklyReset()
	local DTime = {}
	DTime = date('*t') -- hour, min, wday, day, month, year, sec, yday, isdst

	local lastWeeklyQuestResetDate = { }
	lastWeeklyQuestResetDate = DTime --On récpère l'heure actuelle
	lastWeeklyQuestResetDate.hour = WeeklyResetHour
	local lastWeeklyQuestResetTime = time(lastWeeklyQuestResetDate)
	if DTime.wday < WeeklyResetDay then
		lastWeeklyQuestResetTime = lastWeeklyQuestResetTime - ( 24 * 60 * 60 * 7)
	elseif DTime.wday == WeeklyResetDay and DTime.hour < WeeklyResetHour then
		lastWeeklyQuestResetTime = lastWeeklyQuestResetTime - ( 24 * 60 * 60 * 7)
	end
	return lastWeeklyQuestResetTime
end

function RerollManager:LoadSV()
	local lastDailyQuestResetTime = self:GetLastDailyReset()
	local lastWeeklyQuestResetTime = self:GetLastWeeklyReset()
	for k1,v1 in pairs(self.db.char) do
		--print(k1,v1)
		local dbDate, dbDone
		for k2,v2 in pairs(v1) do
			if k2 == "date" then dbDate = v2
			elseif k2 == "done" then dbDone = v2
			end
		end
		if dbDone and dbDone == 2 then
			if dbDate and dbDate < lastDailyQuestResetTime then
				self.db.char[k1]["done"] = 0
				DidIDo[k1] = 0
			else
				DidIDo[k1] = 2
			end
		end
	end
end

function RerollManager:ttformat(text,didido)
	if text then
		if didido == 0 then
			return "|cFFFF0000"..text.."|r"
		elseif didido == 1 then
			return text
		elseif didido == 2 then
			return "|cFF00FF00"..text.."|r"
		end
	end
	return ""
end

function RerollManager:CreateMinimapFrame()
	if LDB then
		local PersoActuel = self.db:GetCurrentProfile()
		local NumPersoSelectionne
		local alt = PersoActuel
		local ListePerso = { }
		local i = 1
		for k,v in pairs(RMdb.char) do
			ListePerso[i] = k
			if k == PersoActuel then NumPersoSelectionne = i end
			i = i + 1
		end
        local RerollManagerLauncher = LDB:NewDataObject("RerollManager", {
            type = "launcher",
            icon = "Interface\\Icons\\INV_Box_01",
            OnClick = function(clickedframe, button)
                if button == "LeftButton" then
					NumPersoSelectionne = NumPersoSelectionne + 1
					if NumPersoSelectionne > #ListePerso then NumPersoSelectionne = 1 end
					alt = ListePerso[NumPersoSelectionne]
				else
					InterfaceOptionsFrame_OpenToCategory("RerollManager")
				end
            end,
            OnTooltipShow = function(tt)
				tt:AddLine("RerollManager :: Recap")
				if alt == PersoActuel then
					self:CheckQuest()
					tt:AddLine("|cFFFFFFFF"..L.RaidIDs.."|r")
					for k,v in pairs(ListRaids) do
						if self.db.char[v].handle then tt:AddLine(self:ttformat(L[v],DidIDo[v])) end
					end
					tt:AddLine(" ")
					tt:AddLine("|cFFFFFFFF"..L.JobQuests.."|r")
					for k,v in pairs(ListJobs) do
						if self.db.char[v].handle then tt:AddLine(self:ttformat(L[v],DidIDo[v])) end
					end
					tt:AddLine(" ")
					tt:AddLine("|cFFFFFFFF"..L.Misc.."|r")
					for k,v in pairs(ListMisc) do
						if self.db.char[v].handle then tt:AddLine(self:ttformat(L[v],DidIDo[v])) end
					end
				else
					tt:AddLine(alt)
					tt:AddLine("|cFFFFFFFF"..L.RaidIDs.."|r")
					for k,v in pairs(ListRaids) do
						if RMdb.char[alt][v] and (RMdb.char[alt][v].handle or DBDefault.char[v].handle) then tt:AddLine(self:ttformat(L[v],RMdb.char[alt][v].done)) end
					end
					tt:AddLine(" ")
					tt:AddLine("|cFFFFFFFF"..L.JobQuests.."|r")
					for k,v in pairs(ListJobs) do
						if RMdb.char[alt][v] and (RMdb.char[alt][v].handle or DBDefault.char[v].handle) then tt:AddLine(self:ttformat(L[v],RMdb.char[alt][v].done)) end
					end
					tt:AddLine(" ")
					tt:AddLine("|cFFFFFFFF"..L.Misc.."|r")
					for k,v in pairs(ListMisc) do
						if RMdb.char[alt][v] and (RMdb.char[alt][v].handle or DBDefault.char[v].handle) then tt:AddLine(self:ttformat(L[v],RMdb.char[alt][v].done)) end
					end
				end
			end
        })
        if LDBIcon then
            LDBIcon:Register("RerollManager", RerollManagerLauncher, self.db.profile.minimap)
        end
    end
end

function RerollManager:SetDailyReset()
	local _,_,_,_,_,_,_,_,isDaylightSavingTime = date('*t')
	if isDaylightSavingTime then DailyReset = 4 end
end

function RerollManager:HandleChatMessages(msg,...)
	local DailiesQuestReset = Deformat(msg, DAILY_QUESTS_REMAINING)
	if DailiesQuestReset == GetMaxDailyQuests() then
		self:LoadSV()
	end
end

function PrintArray()
	for k,v in pairs(DidIDo) do
	print(k,v)
	end
end

RMOptions = {
  type="group",
  args={
	HandleRaid={
	  name=L.RaidIDs,
	  type="group",
	  args={
		HandleICC10={
		  name=L.ICC10,
		  desc=L.ToggleDesc..L.ICC10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.ICC10.handle = val end,
		  get = function(info) return RerollManager.db.char.ICC10.handle end
		},
		HandleICC25={
		  name=L.ICC25,
		  desc=L.ToggleDesc..L.ICC25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.ICC25.handle = val end,
		  get = function(info) return RerollManager.db.char.ICC25.handle end
		},
		HandleArcha10={
		  name=L.Archa10,
		  desc=L.ToggleDesc..L.Archa10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Archa10.handle = val end,
		  get = function(info) return RerollManager.db.char.Archa10.handle end
		},
		HandleArcha25={
		  name=L.Archa25,
		  desc=L.ToggleDesc..L.Archa25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Archa25.handle = val end,
		  get = function(info) return RerollManager.db.char.Archa25.handle end
		},
		HandleRuby10={
		  name=L.Ruby10,
		  desc=L.ToggleDesc..L.Ruby10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Ruby10.handle = val end,
		  get = function(info) return RerollManager.db.char.Ruby10.handle end
		},
		HandleRuby25={
		  name=L.Ruby25,
		  desc=L.ToggleDesc..L.Ruby25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Ruby25.handle = val end,
		  get = function(info) return RerollManager.db.char.Ruby25.handle end
		},
		HandleEDC10={
		  name=L.EDC10,
		  desc=L.ToggleDesc..L.EDC10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.EDC10.handle = val end,
		  get = function(info) return RerollManager.db.char.EDC10.handle end
		},
		HandleEDC25={
		  name=L.EDC25,
		  desc=L.ToggleDesc..L.EDC25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.EDC25.handle = val end,
		  get = function(info) return RerollManager.db.char.EDC25.handle end
		},
		HandleEDC10H={
		  name=L.EDC10H,
		  desc=L.ToggleDesc..L.EDC10H,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.EDC10H.handle = val end,
		  get = function(info) return RerollManager.db.char.EDC10H.handle end
		},
		HandleEDC25H={
		  name=L.EDC25H,
		  desc=L.ToggleDesc..L.EDC25H,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.EDC25H.handle = val end,
		  get = function(info) return RerollManager.db.char.EDC25H.handle end
		},
		HandleOny10={
		  name=L.Ony10,
		  desc=L.ToggleDesc..L.Ony10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Ony10.handle = val end,
		  get = function(info) return RerollManager.db.char.Ony10.handle end
		},
		HandleOny25={
		  name=L.Ony25,
		  desc=L.ToggleDesc..L.Ony25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Ony25.handle = val end,
		  get = function(info) return RerollManager.db.char.Ony25.handle end
		},
		HandleUldu10={
		  name=L.Uldu10,
		  desc=L.ToggleDesc..L.Uldu10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Uldu10.handle = val end,
		  get = function(info) return RerollManager.db.char.Uldu10.handle end
		},
		HandleUldu25={
		  name=L.Uldu25,
		  desc=L.ToggleDesc..L.Uldu25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Uldu25.handle = val end,
		  get = function(info) return RerollManager.db.char.Uldu25.handle end
		},
		HandleMaly10={
		  name=L.Maly10,
		  desc=L.ToggleDesc..L.Maly10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Maly10.handle = val end,
		  get = function(info) return RerollManager.db.char.Maly10.handle end
		},
		HandleMaly25={
		  name=L.Maly25,
		  desc=L.ToggleDesc..L.Maly25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Maly25.handle = val end,
		  get = function(info) return RerollManager.db.char.Maly25.handle end
		},
		HandleSartha10={
		  name=L.Sartha10,
		  desc=L.ToggleDesc..L.Sartha10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Sartha10.handle = val end,
		  get = function(info) return RerollManager.db.char.Sartha10.handle end
		},
		HandleSartha25={
		  name=L.Sartha25,
		  desc=L.ToggleDesc..L.Sartha25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Sartha25.handle = val end,
		  get = function(info) return RerollManager.db.char.Sartha25.handle end
		},
		HandleNaxx10={
		  name=L.Naxx10,
		  desc=L.ToggleDesc..L.Naxx10,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Naxx10.handle = val end,
		  get = function(info) return RerollManager.db.char.Naxx10.handle end
		},
		HandleNaxx25={
		  name=L.Naxx25,
		  desc=L.ToggleDesc..L.Naxx25,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Naxx25.handle = val end,
		  get = function(info) return RerollManager.db.char.Naxx25.handle end
		},
	  },
	},
	HandleJobQuests={
	  name=L.JobQuests,
	  type="group",
	  args={
		HandleCook={
		  name=L.Cook,
		  desc=L.ToggleDesc..L.Cook,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Cook.handle = val end,
		  get = function(info) return RerollManager.db.char.Cook.handle end
		},
		HandleFish={
		  name=L.Fish,
		  desc=L.ToggleDesc..L.Fish,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Fish.handle = val end,
		  get = function(info) return RerollManager.db.char.Fish.handle end
		},
		HandleJC={
		  name=L.JC,
		  desc=L.ToggleDesc..L.JC,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.JC.handle = val end,
		  get = function(info) return RerollManager.db.char.JC.handle end
		},
	  },
	},
	HandleMisc={
	  name=L.Misc,
	  type="group",
	  args={
		HandleBG={
		  name=L.BG,
		  desc=L.ToggleDesc..L.BG,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.BG.handle = val end,
		  get = function(info) return RerollManager.db.char.BG.handle end
		},
		HandleFrost={
		  name=L.Frost,
		  desc=L.ToggleDesc..L.Frost,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Frost.handle = val end,
		  get = function(info) return RerollManager.db.char.Frost.handle end
		},
		HandleWeekly={
		  name=L.Weekly,
		  desc=L.ToggleDesc..L.Weekly,
		  type="toggle",
		  set = function(info,val) RerollManager.db.char.Weekly.handle = val end,
		  get = function(info) return RerollManager.db.char.Weekly.handle end
		},
	  },
	},
  },
}